<?php

namespace App\Controllers;
 
class Report extends BaseController{

    public function __construct()  
    { 
        $this->db = \Config\Database::connect(); 
          
    } 
    public function get_report() {
        $constituency = $this->request->getPost('constituency');
        $mla = $this->request->getPost('mla');
        $department = $this->request->getPost('department');
        $apm = $this->request->getPost('apm');
        $engineer = $this->request->getPost('engineer');
        $year = $this->request->getPost('year');
        // $year = $this->request->getPost('taluk');
    

        $currentYear = date('Y');
        $previousYear = $currentYear - 1;

        $builder = $this->db->table('create_project');
        $builder->select('create_project.*, 
                          department.department_name, 
                          constituency.constituency_name, 
                          constituency_master.mla AS mla, 
                          roles_creation_apm.first_name AS apm_first_name, 
                          roles_creation_engineer.first_name AS engineer_first_name,
                          GROUP_CONCAT(DISTINCT proposal_documents.document_name SEPARATOR ", ") AS proposal_document_names,
                          GROUP_CONCAT(DISTINCT estimation_documents.document_name SEPARATOR ", ") AS estimation_document_names,
                          GROUP_CONCAT(DISTINCT approval_documents.document_name SEPARATOR ", ") AS approval_document_names,
                          COALESCE(total_released.total_released_amount, 0) AS total_released_amount,
                          COALESCE(total_expenditure.total_expenditure, 0) AS total_expenditure,
                          COALESCE(previous_year_released.previous_year_released, 0) AS previous_year_released, 
                          COALESCE(present_year_released.present_year_released, 0) AS present_year_released'); // Add previous and present year released columns
    
  
        $builder->join('department', 'department.id = create_project.department', 'left');
        $builder->join('constituency', 'constituency.id = create_project.constituency', 'left');
        $builder->join('constituency_master', 'constituency_master.constituency_name = create_project.constituency', 'left');
        $builder->join('roles_creation AS roles_creation_apm', 'roles_creation_apm.id = create_project.apm', 'left');
        $builder->join('roles_creation AS roles_creation_engineer', 'roles_creation_engineer.id = create_project.engineer', 'left');
        $builder->join('proposal_documents', 'proposal_documents.project_id = create_project.id', 'left');
        $builder->join('estimation_documents', 'estimation_documents.project_id = create_project.id', 'left');
        $builder->join('approval_documents', 'approval_documents.project_id = create_project.id', 'left');
    
   
        $builder->join('(SELECT project_id, SUM(released_amount) AS total_released_amount FROM released_amounts GROUP BY project_id) AS total_released',
                       'total_released.project_id = create_project.id', 'left');
        
        $builder->join('(SELECT project_id, SUM(expenditure_amount) AS total_expenditure FROM expenditure GROUP BY project_id) AS total_expenditure',
                       'total_expenditure.project_id = create_project.id', 'left');
    
    
        $builder->join("(SELECT project_id, SUM(released_amount) AS previous_year_released 
                         FROM released_amounts 
                         WHERE YEAR(released_date) = $previousYear 
                         GROUP BY project_id) AS previous_year_released", 
                       'previous_year_released.project_id = create_project.id', 'left');
    
        $builder->join("(SELECT project_id, SUM(released_amount) AS present_year_released 
                         FROM released_amounts 
                         WHERE YEAR(released_date) = $currentYear 
                         GROUP BY project_id) AS present_year_released", 
                       'present_year_released.project_id = create_project.id', 'left');
    
       
        $builder->groupBy('create_project.id');
    
      
        if (!empty($constituency) || !empty($mla) || !empty($department) || !empty($apm) || !empty($year)) {
            if (!empty($constituency)) {
                $builder->where('create_project.constituency', $constituency);
            }
            if (!empty($mla)) {
                $builder->where('constituency_master.mla', $mla);
            }
            if (!empty($department)) {
                $builder->where('create_project.department', $department);
            }
            if (!empty($apm)) {
                $builder->where('create_project.apm', $apm);
            }
            if (!empty($year)) {
                $builder->where('create_project.financial_year', $year);
            }
            if (!empty($engineer)) {
                $builder->where('create_project.engineer',$engineer);
            }
            //  if (!empty($taluk)) {
            //     $builder->where('create_project.taluk',$taluk);
            // }
        } else {
            $builder->where('YEAR(create_project.created_at)', $currentYear);
        }
    
        // Order the results
        $builder->orderBy('department.department_name', 'ASC');
        $builder->orderBy('constituency.constituency_name', 'ASC');
        $builder->orderBy('constituency_master.mla', 'ASC');
    
        // Execute the query
        $query = $builder->get();
        $result = $query->getResultArray();
    
        // Return the response as JSON
        return $this->response->setJSON(['result' => 1, 'table' => $result]);
    }
    




















}

?>