<?php

use CodeIgniter\Router\RouteCollection;

/**
 * @var RouteCollection $routes
 */
$routes->get('/', 'Home::index');
$routes->get('user/create', 'Login::createUserAndSendCredentials');
$routes->get('loginpage','Login::index');
$routes->post('login','Login::login');
$routes->add('logout','Login::logout');

//Home
$routes->get('Dashboard','Dashboard::index');
$routes->get('createproject','Home::project');
$routes->get('projectlist','Home::projectlist');
$routes->get('createConstituency','Home::constituency');
$routes->get('department','Home::department');
$routes->get('status-master','Home::status_master');
$routes->get('addemployee','Home::add_employee');
$routes->get('roles','Home::roles');
$routes->get('roleCreation','Home::roleCreation');
$routes->get('fund-master','Home::fund_master');
$routes->get('constituency-master','Home::constituency_master');
$routes->get('report1','Home::report');
$routes->get('report','Home::reportNew');
$routes->get('report-details','Home::report_details');
$routes->get(' report2','Home::report2');
$routes->get('instructions','Home::instructions');


//create project
$routes->post('create-project','Project::create_project');
$routes->get('fetch-department','Project::fetch_department');
$routes->get('fetch-Constituency','Project::fetch_Constituency');
$routes->get('project-list-data','Project::project_list_data');
$routes->post('project-delete/(:num)','Project::project_delete/$1');
$routes->get('project-edit/(:num)','Project::project_edit/$1');
$routes->get('fetch-supervisor','Project::fetch_supervisor');
$routes->get('fetch-engineer','Project::fetch_engineer');
$routes->post('project/delete_document','Project::delete_document');
$routes->post('project/delete_released_amount','Project::delete_released_amount');
$routes->post('project/delete-expenditure-amount','Project::delete_expenditure_amount');
$routes->post('project-update/(:num)','Project::update_project/$1');
$routes->post('project-update-payment/(:num)','Project::project_update_payment/$1');
$routes->get('project-payment-edit/(:num)','Project::project_payment_edit/$1');
$routes->post('delete-proposal-document','Project::delete_proposal_document');
$routes->post('delete-approval-document','Project::delete_approval_document');
$routes->post('delete-estimation-documents','Project::delete_estimate_document');
$routes->get('fetch-mla-by-constituency/(:num)','Project::fetch_mla_by_constituency/$1');
$routes->get('fetch-mla-without-constituency','Project::fetch_mla_without_constituency');



//create department
$routes->post('create_department','Department::create_department');
$routes->get('department-list-data','Department::department_list_data');
$routes->post('department-delete/(:num)','Department::department_delete/$1');
$routes->get('edit-department-data/(:num)','Department::edit_department_data/$1');
$routes->post('update-department','Department::update_department');
$routes->post('status-create','Department::status_create');
$routes->post('create-fund','Department::create_fund');
$routes->get ('fund-list-data','Department::fund_list_data');
$routes->post('fund-delete/(:num)','Department::fund_delete/$1');
$routes->get('edit-fund-data/(:num)','Department::edit_fund_data/$1');
$routes->post('constituency-master-delete/(:num)','Department::constituency_master_delete/$1');
$routes->get('constituency-master-edit/(:num)','Department::constituency_master_edit/$1');
$routes->post('update-fund','Department::update_fund');
$routes->post('update-constituency-master','Department::update_constituency_master');
$routes->get('fetch-status','Department::fetch_status');
$routes->get('fetch-fund','Department::fetch_funds');
$routes->get('fetch-constituency','Department::fetch_constituency');
$routes->get('fetch-mla','Department::fetch_mla');
$routes->get('constituency-master-data','Department::constituency_list_data');

//constituency
$routes->post('create-constituency','Constituency::create_constituency');
$routes->get('constituency-list-data','Constituency::constituency_list_data');
$routes->post('constituency-delete/(:num)','Constituency::constituency_delete/$1');
$routes->get('edit-constituency-data/(:num)','Constituency::edit_constituency_data/$1');
$routes->post('update-constituency','Constituency::update_constituency');
$routes->post('constituency-master','Constituency::constituency_master');
$routes->post('checkNameExists','Roles::checkNameExists');

//Roles
$routes->get('roles-data','Roles::role_data');
$routes->post('roles-delete/(:num)','Roles::role_delete/$1');
$routes->get('edit-roles-data/(:num)','Roles::edit_roles_data/$1');
$routes->get('fetch-roles','Roles::fetch_roles');
$routes->post('update-role-creation','Roles::update_role_creation');
$routes->get('fetch-roles-data','Roles::fetch_admin');  
$routes->get('fetch-apm','Roles::fetch_apm');  
$routes->get('fetch-supervisor','Roles::fetch_supervisor');  
$routes->post('add-roles-creation','Roles::add_roles_creation');     
$routes->get('fetch-firstname','Roles::fetch_firstname');     

//Report

$routes->post('get_report','Report::get_report');
// $routes->post('get_report','Report::report_details');
$routes->post('get_report1','Report::get_report_cosntituency');
//  $routes->post('get_report_total','Report::get_report_total');


//Notification

$routes->get('notifications','Notification::index');
$routes->post('notifications/mark_as_read','Notification::mark_read');
$routes->post('getUsersByRole','Notification::getUsersByRole');
$routes->post('send-notification','Notification::send_Notification');

// $routes->get('Roles/view', 'Roles::view');
// $routes->get('Roles/getById', 'Roles::getById'); 
// $routes->post('Roles/update', 'Roles::update');
// $routes->delete('Roles/delete/(:num)', 'Roles::delete/$1');
