<?php 

namespace App\Controllers;

class Notification extends BaseController{
    
 public function __construct()  
    { 
        $this->db = \Config\Database::connect(); 
          date_default_timezone_set('Asia/Kolkata');
          
}     
    
public function index() {
   
    $currentUserId = session()->get('id');


    $builder = $this->db->table('notifications');
    $notifications = $builder->select('*')
                             ->where('user_id', $currentUserId) // Filter by the current user's ID
                             ->where('status', '0') // Only unread notifications
                             ->orderBy('created_at', 'DESC')
                             ->get()
                             ->getResultArray();

    $unreadCount = count($notifications);

    // Return the response as JSON
    return $this->response->setJSON([
        'notifications' => $notifications,
        'unreadCount' => $unreadCount
    ]);
}

public function mark_read(){
    

    $builder = $this->db->table('notifications');
    $builder->where('status', '0');
    $builder->update(['status' => '1']);

    return $this->response->setJSON(['result' => 1, 'message' => 'Notifications marked as read']);  
    
    
}
    
   
// public function getUsersByRole() {
//     $role = $this->request->getPost('role');
//     $builder = $this->db->table('users');
//     $users = $builder->select('id, username') 
//                      ->where('role', $role) 
//                      ->get()
//                      ->getResultArray();

//     return $this->response->setJSON($users); 
// }

public function getUsersByRole()
{

    $role = $this->request->getPost('role');

    $builder = $this->db->table('users');


    if ($role === 'all' || empty($role)) {
        // Fetch all users
        $users = $builder->select('id, username')->get()->getResultArray();
    } else {
        // Fetch users by role
        $users = $builder->select('id, username')
            ->where('role', $role)
            ->get()
            ->getResultArray();
    }

    // Prepare the response
    $response = [];
    foreach ($users as $user) {
        $response[] = [
            'id' => $user['id'],
            'username' => $user['username']
        ];
    }

    // Return the users in JSON format
    return $this->response->setJSON($response);
}


public function send_Notification() {
    
    $selectedUsers = $this->request->getPost('users'); // Array of selected user IDs
    $message = $this->request->getPost('message'); // Get the message

    if (!empty($selectedUsers)) {
        foreach ($selectedUsers as $userId) {
        
            $data = [
                'user_id' => $userId,
                'message' => $message,
                'status' => 0, // Unread
                'created_at' => date('Y-m-d H:i:s')
            ];
            $this->db->table('notifications')->insert($data);
        }
        return $this->response->setJSON(['result'=>1, 'message' => 'Notifications sent successfully!']);
    } else {
        return $this->response->setJSON(['status' => 'error', 'message' => 'No users selected']);
    }
}
 
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}





































?>