<?php echo view('includes/sidebar'); ?>
<script type="text/javascript" src="<?php echo base_url('public/assets/js/jquery-3.6.0.min.js'); ?>"></script>
<script src="<?php echo base_url('public/assets/toastr/toastr.min.js');?>"></script>
<link rel="stylesheet" href="<?php echo base_url('public/assets/toastr/toastr.min.css');?>">
<link rel="stylesheet" href="https://cdn.datatables.net/1.11.5/css/jquery.dataTables.min.css">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"></script>


<script src="https://cdn.datatables.net/1.11.5/js/jquery.dataTables.min.js"></script>


<section class="home-section">
    <div class="home-content">
        <i class='bx bx-menu'></i>
        <!-- <span class="text">Drop Down Sidebar</span> -->
    </div>
    <div class="row m-0">
        <div class="col-sm-12">
            <h1 class="crt-pjt">Project List</h1>
        </div>
    </div>
    <div class="container-fluid inp-lbl">
        <table id="datatable" class="display" style="width:100%">
            <thead>
                <tr>
                    <th>SL NO</th>
                    <th></th>
                    <th>ID</th>
                    <th class="width">Project Name</th>
                    <th>Department</th>
                    <th>Constituency</th>
                    <th>MP/MLA/MLC</th>
                    <th>Date of proposal</th>
                    <th>Submission Date</th>
                    <th>Estimated Cost</th>
                    <th>Date Of Approval</th>
                    <th>Total Released Amount</th>
                    <th>APM</th>
                    <th>Engineer</th>
                    <th>Supervisor</th>
                    <th>Start Date</th>
                    <th>Action</th>

                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>

        <div id="resultID"></div>
    </div>

</section>



<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.10.8/dist/sweetalert2.all.min.js"></script>
<link href="https://cdn.jsdelivr.net/npm/sweetalert2@11.10.8/dist/sweetalert2.min.css" rel="stylesheet">


<script>
    var role = '<?php echo session()->get('role');?>';

    $(document).ready(function () {
        var table = $('#datatable').DataTable({
            pageLength: 20,
            scrollX: true,
            scrollCollapse: true,
            ajax: {
                url: '<?php echo base_url("project-list-data"); ?>',
                dataSrc: function (json) {
                    return json;
                }
            },
            columns: [
                {
                    data: null,
                    orderable: false,
                    className: 'dt-center',
                    render: function (data, type, row, meta) {
                        return meta.row + meta.settings._iDisplayStart + 1;
                    }
                },
                {
                    className: 'details-control',
                    orderable: false,
                    data: null,
                    defaultContent: '<i class="fa fa-plus" style="cursor: pointer;"></i>',
                },
                { data: 'id', visible: false },
                { data: 'project_name' },
                { data: 'department_name' },
                { data: 'constituency_name' },
                { data: 'mla' },
                { data: 'date_of_Proposal' },
                { data: 'est_sub_date' },
                { data: 'estimated_cost' },
                { data: 'date_of_approval' },
                { data: 'total_released_amount' },
                { data: 'apm_first_name', title: 'APM' },
                { data: 'engineer_first_name', title: 'Engineer' },
                { data: 'supervisor_first_name', title: 'supervisor' },
                { data: 'start_date', title: 'Start Date' },
                {
                    data: null,
                    render: function (data, type, row) {
                        let buttons = '';

                      
                        
                            buttons += `<button class="btn edit--butt" onclick="Edit(${row.id})">Edit</button>`;
                            if (role == 0 || role == 1) {
                            buttons += `<button class="btn delete--butt" onclick="Delete(${row.id})">Delete</button>`;
                        }

                     if(role != 4)
                        buttons += `<button class="btn edit--butt" onclick="Editpayment(${row.id})">Payment</button>`;
                        return `<div class="crud--buttons">${buttons}</div>`;
                    }
                }
            ],
            rowCallback: function (row, data, index) {
                $('td:eq(0)', row).html(index + 1); // Update S.No
            },
            language: {
                emptyTable: "No data available"
            },
            columnDefs: [
                { targets: [1, 2], width: '10px' },
                { targets: [3, 4, 5, 6, 7], },
                { targets: '_all', className: 'dt-center' }
            ]
        });

        $('#datatable tbody').on('click', 'td.details-control i', function () {
            const tr = $(this).closest('tr');
            const row = table.row(tr);

            if (row.child.isShown()) {
                row.child.hide();
                tr.removeClass('shown');
            } else {
                const data = row.data();
                if (data) {
                    row.child(formatSubgrid(data)).show();
                    tr.addClass('shown');
                } else {
                    row.child('<div>No data available</div>').show();
                    tr.addClass('shown');
                }
            }
        });
    });
    function formatSubgrid(data) {
        let subgridHtml = '<table class="subgrid-table" cellpadding="5" cellspacing="0" border="1" style="padding-left:50px; background-color: #f9f9f9;">';
        subgridHtml += '<tr><th>ADM Amount</th><th>Fund Wise</th><th>Financial Year</th><th>Total Expenditure</th><th>Status</th><th>Labour Contract</th><th>Remarks</th><th>Proposal Documents</th><th>Estimation Documents</th><th>Approval Documents</th></tr>';

        let proposalDocumentNames = formatProposalDocuments(data.proposal_document_names);
        let estimationDocumentNames = formatEstimationDocuments(data.estimation_document_names);
        let approvalDocumentNames = formatApprovalDocuments(data.approval_document_names);


        subgridHtml += `<tr>
        <td>${data.adm_amount}</td>
        <td>${data.fund_name ||''}</td>
        <td>${data.financial_year}</td>
        <td>${data.total_expenditure}</td>
       <td>${data.status_name || ''}</td>
        <td>${data.labour_contract}</td>
        <td>${data.remarks}</td>
        <td>${proposalDocumentNames}</td>
        <td>${estimationDocumentNames}</td>
        <td>${approvalDocumentNames}</td>
    </tr>`;

        subgridHtml += '</table>';
        return subgridHtml;
    }


    function formatProposalDocuments(proposal_document_names) {
        if (proposal_document_names) {
            const docsArray = proposal_document_names.split(', ');
            return docsArray.map(doc =>
                `<a href="public/proposal_documents/${doc}" target="_blank">${doc}</a>`
            ).join(', ');
        } else {
            return 'No documents available';
        }
    }

    function formatEstimationDocuments(estimation_document_names) {
        if (estimation_document_names) {
            const docsArray = estimation_document_names.split(', ');
            return docsArray.map(doc =>
                `<a href="public/estimation_documents/${doc}" target="_blank">${doc}</a>`
            ).join(', ');
        } else {
            return 'No documents available';
        }
    }

    function formatApprovalDocuments(approval_document_names) {
        if (approval_document_names) {
            const docsArray = approval_document_names.split(', ');
            return docsArray.map(doc =>
                `<a href="public/approval_documents/${doc}" target="_blank">${doc}</a>`
            ).join(', ');
        } else {
            return 'No documents available';
        }
    }

    function formatReleasedAmounts(releasedAmounts) {
        if (releasedAmounts) {
            const amountsArray = releasedAmounts.split(', ');
            return amountsArray.map(amount => `${parseFloat(amount)}`).join(', ');
        } else {
            return 'No released amounts available';
        }
    }
</script>


<script>
    function Edit(id) {
        window.location.href = '<?php echo base_url('project-edit/') ?>' +id;
    }
</script>

<script>
    function Editpayment(id) {
        window.location.href = '<?php echo base_url('project-payment-edit/') ?>' +id;
    }
</script>



<script>
    function Delete(Id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: '<?php echo base_url('project-delete/')?>'+Id,
                method: 'POST',
                    dataType: 'json',
                        success: function (response) {
                            if (response.result == 1) {
                                Swal.fire({
                                    icon: "success",
                                    title: response.message,
                                    showConfirmButton: false,
                                    timer: 2000
                                });

                                $('#datatable').DataTable().ajax.reload(null, false);
                            } else {
                                Swal.fire({
                                    icon: "error",
                                    title: "Failed to delete project",
                                    showConfirmButton: false,
                                    timer: 2000
                                });
                            }
                        },
                error: function () {
                    console.log('Error deleting project');
                }
            });
    }
    });
}
</script>
<script>
    let arrow = document.querySelectorAll(".arrow");
    for (var i = 0; i < arrow.length; i++) {
        arrow[i].addEventListener("click", (e) => {
            let arrowParent = e.target.parentElement.parentElement;
            arrowParent.classList.toggle("showMenu");
        });
    }
    let sidebar = document.querySelector(".sidebar");
    let sidebarBtn = document.querySelector(".bx-menu");
    console.log(sidebarBtn);
    sidebarBtn.addEventListener("click", () => {
        sidebar.classList.toggle("close");
    });
</script>
<?php echo view('includes/footer'); ?>
<style>
    .table-responsive {
        overflow-x: auto;
    }

    table.dataTable {
        width: 100%;
        border-collapse: collapse;
    }

    table.dataTable th,
    table.dataTable td {
        padding: 5px 10px;
        text-align: center;
        font-size: 0.9em;
    }

    table.dataTable th {
        background-color: #f2f2f2;
        border-bottom: 2px solid #ddd;
    }

    table.dataTable tr:nth-child(even) {
        background-color: #f9f9f9;
    }

    table.dataTable tr:hover {
        background-color: #f1f1f1;
    }

    .crud--buttons {
        display: flex;
        justify-content: center;
    }

    .btn {
        margin: 0 5px;
        padding: 5px 10px;
        font-size: 0.8em;
    }

    .btn.edit--butt {
        background-color: #4CAF50;
        color: white;
    }

    .btn.delete--butt {
        background-color: #f44336;
        color: white;
    }

    .subgrid-table {
        width: 100%;
        margin-top: 5px;
        border-collapse: collapse;
    }

    .subgrid-table th,
    .subgrid-table td {
        padding: 2px;
        border: 1px solid #ddd;
    }
</style>